import java.awt.*;
import java.util.*;

public class Steuerung implements Runnable { // zustzliche Schnittstelle Runnable
  private Oberflaeche dieOberflaeche;
  private Vector scene = new Vector();
  private int zeitScheiben;
  
  public Steuerung(Oberflaeche ober){
    dieOberflaeche = ober;  
    scene.add(new Spider(100,100,30,0));
    scene.add(new Spider(200,200,50,1));
    scene.add(new Fliege(300,300,40,4));
    Thread liveDaemon = new Thread(this);  // neuen Thread erzeugen
    liveDaemon.start();  // Thread starten
  }
  
  public void malen(Graphics g){
    //Iterator it = scene.iterator();
    Enumeration auz = scene.elements();
    while (auz.hasMoreElements()){    
      Viech v = (Viech) auz.nextElement();
      v.malen(g);
    }  
  }
  
  public void klick(int x, int y){
    Iterator it = scene.iterator();
    while (it.hasNext()){
      Viech v = (Viech) it.next();
      if (v.getroffen(x,y))
        it.remove();
      else
        v.geheZu(x,y);
    }  
  }
  
  public void shiftKlick(int x, int y){
    if (Math.random()> 0.25)
      scene.addElement(new Fliege(x,y,(int)(Math.random()*30)+10,(int)(Math.random()*dieOberflaeche.fliege.length)));
    else
      scene.addElement(new Spider(x,y,(int)(Math.random()*40)+10,(int)(Math.random()*dieOberflaeche.spinne.length)));
  }
  
  public void leben(){
    //Iterator it = scene.iterator();
    zeitScheiben++;
    if (zeitScheiben % 100 == 15) shiftKlick((int)(Math.random()*500),(int)(Math.random()*500));
    Enumeration auz = scene.elements();
    //while (it.hasNext()){
    while (auz.hasMoreElements()){    
      //Viech v = (Viech) it.next();
      Viech v = (Viech) auz.nextElement();
      v.leben(scene);
    }    
  }
  
  public void run() {// das ist der Thread, hier steckt das Leben drin
    while (true){ // solange immer
      leben();
      dieOberflaeche.repaint();     // neu zeichnen
      try {
        Thread.sleep (80);  // ein wenig schlafen
      }
        catch (InterruptedException ex){
      }
    }  
  }
}
